<?php 
/* PHP-GD implement
** Library BMP
** v1.0 by NoNo-ServeuR.net
* 
* Work with:
* - 32bits
* - 24bits
* - 16bits
* - 8bits
* - 4bits
* - 1bits
* 
* Function:
* - getimagesizebmp($filename)		----> return array(width,height,depth)
* - imagecreatefrombmp($filename)	----> return gdimage
*/ 

function getimagesizebmp($filename){ //########################################### Begin of "getimagesizebmp"
	if (!file_exists($filename)){return false;} //if bad filename
	if (file_get_contents($filename,NULL,NULL,0,2)!=="BM"){return false;} //if filetype
	
	$FileContent = file_get_contents($filename,NULL,NULL,0,54); //read file content
	extract(unpack("vtype/Vlength/v2reserved/Vbegin/Vsize/Vwidth/Vheight/vplanes/vbits/Vcompression/Vimagesize/Vxres/Vyres/Vncolor/Vimportant", $FileContent)); //get header data
	return array($width,$height,$bits);
} //############################################################################## End of "getimagesizebmp"

function imagecreatefrombmp($filename,$dev=false){ //############################# Begin of "imagecreatefrombmp"
	$StartTime = microtime(true);
	if (!file_exists($filename)){return false;} //if bad filename
	if (file_get_contents($filename,NULL,NULL,0,2)!=="BM"){return false;} //if filetype
	
	$FileContent = file_get_contents($filename); //read file content
	extract(unpack("vtype/Vlength/v2reserved/Vbegin/Vsize/Vwidth/Vheight/vplanes/vbits/Vcompression/Vimagesize/Vxres/Vyres/Vncolor/Vimportant", $FileContent)); //get header data

	$TmpImg = imagecreatetruecolor($width,$height); //create the temp picture
	$i = 0; //create current pointer
	
	if($bits == 32){ //####################################### if 32bits bitmap #######################################
		imagefill($TmpImg,0,0,imagecolorallocatealpha($TmpImg,255,255,255,127));
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$width;$x++) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,4); //temp string to increase performance
				imagesetpixel($TmpImg,$x,$y,imagecolorallocatealpha($TmpImg,ord($TmpStr[2]),ord($TmpStr[1]),ord($TmpStr[0]),127-floor(ord($TmpStr[3])/2))); //set color in pixel
				$i += 4; //moving pointer
			}
		}
	}else if($bits == 24){ //####################################### if 24bits bitmap #######################################
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$width;$x++) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,3); //temp string to increase performance
				imagesetpixel($TmpImg,$x,$y,imagecolorallocate($TmpImg,ord($TmpStr[2]),ord($TmpStr[1]),ord($TmpStr[0]))); //set color in pixel
				$i += 3; //moving pointer
			}
		}
	}else if($bits == 16){ //####################################### if 16bits bitmap #######################################
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$width;$x++) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,2); //temp string to increase performance
				$TmpStr = str_pad(decbin(ord($TmpStr[1])).str_pad(decbin(ord($TmpStr[0])), 8, "0", STR_PAD_LEFT), 16, "0", STR_PAD_LEFT); //converting in rgb
				imagesetpixel($TmpImg,$x,$y,imagecolorallocate($TmpImg,bindec(substr($TmpStr,1,5))*8,bindec(substr($TmpStr,6,5))*8,bindec(substr($TmpStr,11,5))*8)); //set color in pixel
				$i += 2; //moving pointer
			}
		}
	}else if($bits == 8){ //####################################### if 8bits bitmap #######################################
		$ImgPal = substr($FileContent,54,1024); //extrat bitmap palette
		for($p=0;$p<1024;$p+=4){ //generate pal array
			$Pal8Bits[$i] = array("r"=>ord($ImgPal[$p+2]),"g"=>ord($ImgPal[$p+1]),"b"=>ord($ImgPal[$p])); //put color in array
			$i++; //hex pointer
		}
		
		$i = 0; //reset pointer
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$width;$x++) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,1); //temp string to increase performance
				imagesetpixel($TmpImg,$x,$y,imagecolorallocate($TmpImg,$Pal8Bits[ord($TmpStr)]["r"],$Pal8Bits[ord($TmpStr)]["g"],$Pal8Bits[ord($TmpStr)]["b"]));
				$i+=1;
			}
		}
	}else if($bits == 4){ //####################################### if 4bits bitmap #######################################
		$ImgPal = substr($FileContent,54,64); //extrat bitmap palette
		for($p=0;$p<64;$p+=4){ //generate pal array
			if($i>9){$i="a";} //hex loop
			$Pal4Bits[$i] = array("r"=>ord($ImgPal[$p+2]),"g"=>ord($ImgPal[$p+1]),"b"=>ord($ImgPal[$p])); //put color in array
			$i++; //hex pointer
		}

		$i = 0; //reset pointer
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$width;$x+=2) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,1); //temp string to increase performance
				$TmpStr = bin2hex($TmpStr[0]); //convert to hex
				for($a=0;$a<2;$a++){
					imagesetpixel($TmpImg,$x+$a,$y,imagecolorallocate($TmpImg,$Pal4Bits[$TmpStr[$a]]["r"],$Pal4Bits[$TmpStr[$a]]["g"],$Pal4Bits[$TmpStr[$a]]["b"]));
				}
				$i+=1;
			}
		}
	}else if($bits == 1){ //####################################### if 1bits bitmap #######################################
		$widthby32 = ceil($width/32)*32; //1bits bitmap is formated by 32px in width
		for($y=$height-1;$y>=0;$y--) { //Y loop
			for($x=0;$x<$widthby32;$x+=8) { //X loop
				$TmpStr = substr($FileContent,$begin+$i,1); //temp string to increase performance
				$TmpStr = bin2hex($TmpStr[0]); //convert to hex
				$TmpStr = str_pad(decbin(hexdec(substr($TmpStr,0,1))), 4, "0", STR_PAD_LEFT).str_pad(decbin(hexdec(substr($TmpStr,1,1))), 4, "0", STR_PAD_LEFT); //converting char in binary
				for($a=0;$a<8;$a++){
					if($TmpStr[$a]=='1'){imagesetpixel($TmpImg,$x+$a,$y,imagecolorallocate($TmpImg,255,255,255));} //set white pixel only
				}
				$i+=1;
			}
		}
	}
	$EndTime = microtime(true)-$StartTime;
	
	if($dev){
		imagestring($TmpImg,2,5,5,$width.'x'.$height."   ".$bits.'bits   generate in '.round($EndTime,2).'s',imagecolorallocate($TmpImg,0,0,0));
	}
	
	imagealphablending($TmpImg, true);
	imageSaveAlpha($TmpImg, true);
	
	return $TmpImg; //return picture in gd format
} //############################################################################## End of "imagecreatefrombmp"


//###################### DEMO #############################
header("Content-type: image/png");
$image = imagecreatefrombmp("file.bmp");
imagepng($image);
imagedestroy($image);
?>